<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.util.intcoll;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.Serializable;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.lang.reflect.Array;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.util.Comparator;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.util.Iterator;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.util.NoSuchElementException;<a name="line.40"></a>
<FONT color="green">041</FONT>    <a name="line.41"></a>
<FONT color="green">042</FONT>    /**<a name="line.42"></a>
<FONT color="green">043</FONT>     * Implementation of IntSet, also implementing SortedSet, for an integer range.<a name="line.43"></a>
<FONT color="green">044</FONT>     * All values in this range are members of this set, the set is unmodifiable.<a name="line.44"></a>
<FONT color="green">045</FONT>     */<a name="line.45"></a>
<FONT color="green">046</FONT>    public class RangeIntSet extends AbstractSortedIntSet implements Serializable {<a name="line.46"></a>
<FONT color="green">047</FONT>    <a name="line.47"></a>
<FONT color="green">048</FONT>            private static final long serialVersionUID = -2184524474112335289L;<a name="line.48"></a>
<FONT color="green">049</FONT>            private final int start;//inclusive<a name="line.49"></a>
<FONT color="green">050</FONT>            private final int end;//exclusive<a name="line.50"></a>
<FONT color="green">051</FONT>            <a name="line.51"></a>
<FONT color="green">052</FONT>            /**<a name="line.52"></a>
<FONT color="green">053</FONT>             * Constructor for &lt;code&gt;RangeIntSet&lt;/code&gt; start index (inclusive) and<a name="line.53"></a>
<FONT color="green">054</FONT>             * end index (exclusive).<a name="line.54"></a>
<FONT color="green">055</FONT>             * <a name="line.55"></a>
<FONT color="green">056</FONT>             * @param start the first index in the range (inclusive)<a name="line.56"></a>
<FONT color="green">057</FONT>             * @param end   the first index out of the range (exclusive)<a name="line.57"></a>
<FONT color="green">058</FONT>             */<a name="line.58"></a>
<FONT color="green">059</FONT>            public RangeIntSet(int start, int end) {<a name="line.59"></a>
<FONT color="green">060</FONT>                    if (end &lt; start) {<a name="line.60"></a>
<FONT color="green">061</FONT>                            throw new IllegalArgumentException("start must be greater or equal to end: " + end + " not &gt;= " + start);<a name="line.61"></a>
<FONT color="green">062</FONT>                    }<a name="line.62"></a>
<FONT color="green">063</FONT>                    this.start      = start;<a name="line.63"></a>
<FONT color="green">064</FONT>                    this.end        = end;<a name="line.64"></a>
<FONT color="green">065</FONT>            }<a name="line.65"></a>
<FONT color="green">066</FONT>    <a name="line.66"></a>
<FONT color="green">067</FONT>            @Override<a name="line.67"></a>
<FONT color="green">068</FONT>            public int size() {<a name="line.68"></a>
<FONT color="green">069</FONT>                    return end - start;<a name="line.69"></a>
<FONT color="green">070</FONT>            }<a name="line.70"></a>
<FONT color="green">071</FONT>    <a name="line.71"></a>
<FONT color="green">072</FONT>            @Override<a name="line.72"></a>
<FONT color="green">073</FONT>            public boolean isEmpty() {<a name="line.73"></a>
<FONT color="green">074</FONT>                    return end == start;<a name="line.74"></a>
<FONT color="green">075</FONT>            }<a name="line.75"></a>
<FONT color="green">076</FONT>    <a name="line.76"></a>
<FONT color="green">077</FONT>            @Override<a name="line.77"></a>
<FONT color="green">078</FONT>            public boolean containsInt(int o) {<a name="line.78"></a>
<FONT color="green">079</FONT>                    return o &gt;= start &amp;&amp; o &lt; end;<a name="line.79"></a>
<FONT color="green">080</FONT>            }<a name="line.80"></a>
<FONT color="green">081</FONT>    <a name="line.81"></a>
<FONT color="green">082</FONT>            @Override<a name="line.82"></a>
<FONT color="green">083</FONT>            public Iterator&lt;Integer&gt; iterator() {<a name="line.83"></a>
<FONT color="green">084</FONT>                    return intIterator();<a name="line.84"></a>
<FONT color="green">085</FONT>            }<a name="line.85"></a>
<FONT color="green">086</FONT>    <a name="line.86"></a>
<FONT color="green">087</FONT>            @Override<a name="line.87"></a>
<FONT color="green">088</FONT>            @SuppressWarnings("unchecked")<a name="line.88"></a>
<FONT color="green">089</FONT>            protected &lt;T&gt; T[] toArrayInternal(T[] arr, boolean checkSize) {<a name="line.89"></a>
<FONT color="green">090</FONT>                    if (checkSize) {<a name="line.90"></a>
<FONT color="green">091</FONT>                            int size = size();<a name="line.91"></a>
<FONT color="green">092</FONT>                            if (arr.length &lt; size) {<a name="line.92"></a>
<FONT color="green">093</FONT>                                    arr = (T[])Array.newInstance(arr.getClass().getComponentType(), size);<a name="line.93"></a>
<FONT color="green">094</FONT>                            }                       <a name="line.94"></a>
<FONT color="green">095</FONT>                    }<a name="line.95"></a>
<FONT color="green">096</FONT>                    int index = 0;<a name="line.96"></a>
<FONT color="green">097</FONT>                    for (int i = start; i &lt; end; i++) {<a name="line.97"></a>
<FONT color="green">098</FONT>                            arr[index++] = (T)Integer.valueOf(i); <a name="line.98"></a>
<FONT color="green">099</FONT>                    }<a name="line.99"></a>
<FONT color="green">100</FONT>                    return arr;<a name="line.100"></a>
<FONT color="green">101</FONT>            }<a name="line.101"></a>
<FONT color="green">102</FONT>    <a name="line.102"></a>
<FONT color="green">103</FONT>            @Override<a name="line.103"></a>
<FONT color="green">104</FONT>            public void clear() {<a name="line.104"></a>
<FONT color="green">105</FONT>                    throw new UnsupportedOperationException("unmodifiable set");<a name="line.105"></a>
<FONT color="green">106</FONT>            }<a name="line.106"></a>
<FONT color="green">107</FONT>    <a name="line.107"></a>
<FONT color="green">108</FONT>            @Override<a name="line.108"></a>
<FONT color="green">109</FONT>            public boolean addInt(int value) {<a name="line.109"></a>
<FONT color="green">110</FONT>                    throw new UnsupportedOperationException("unmodifiable set");<a name="line.110"></a>
<FONT color="green">111</FONT>            }<a name="line.111"></a>
<FONT color="green">112</FONT>            <a name="line.112"></a>
<FONT color="green">113</FONT>            @Override<a name="line.113"></a>
<FONT color="green">114</FONT>            public boolean removeInt(int value) {<a name="line.114"></a>
<FONT color="green">115</FONT>                    throw new UnsupportedOperationException("unmodifiable set");<a name="line.115"></a>
<FONT color="green">116</FONT>            }<a name="line.116"></a>
<FONT color="green">117</FONT>    <a name="line.117"></a>
<FONT color="green">118</FONT>            @Override<a name="line.118"></a>
<FONT color="green">119</FONT>            public IntIterator intIterator() {<a name="line.119"></a>
<FONT color="green">120</FONT>                    return new AbstractIntIterator() {<a name="line.120"></a>
<FONT color="green">121</FONT>                            int next = start;<a name="line.121"></a>
<FONT color="green">122</FONT>                            public boolean hasNext() {<a name="line.122"></a>
<FONT color="green">123</FONT>                                    return next &lt; end;<a name="line.123"></a>
<FONT color="green">124</FONT>                            }<a name="line.124"></a>
<FONT color="green">125</FONT>                            public int nextInt() {<a name="line.125"></a>
<FONT color="green">126</FONT>                                    if (next &gt;= end) throw new NoSuchElementException();<a name="line.126"></a>
<FONT color="green">127</FONT>                                    final int cur = next;<a name="line.127"></a>
<FONT color="green">128</FONT>                                    next++;<a name="line.128"></a>
<FONT color="green">129</FONT>                                    return cur;<a name="line.129"></a>
<FONT color="green">130</FONT>                            }<a name="line.130"></a>
<FONT color="green">131</FONT>                            @Override<a name="line.131"></a>
<FONT color="green">132</FONT>                            public void remove() {<a name="line.132"></a>
<FONT color="green">133</FONT>                                    throw new UnsupportedOperationException("unmodifiable set");<a name="line.133"></a>
<FONT color="green">134</FONT>                            }<a name="line.134"></a>
<FONT color="green">135</FONT>                    };<a name="line.135"></a>
<FONT color="green">136</FONT>            }<a name="line.136"></a>
<FONT color="green">137</FONT>    <a name="line.137"></a>
<FONT color="green">138</FONT>            @Override<a name="line.138"></a>
<FONT color="green">139</FONT>            protected int[] toIntArrayInternal(int[] arr, boolean checkSize) {<a name="line.139"></a>
<FONT color="green">140</FONT>                    if (checkSize) {<a name="line.140"></a>
<FONT color="green">141</FONT>                            int size = size();<a name="line.141"></a>
<FONT color="green">142</FONT>                            if (arr.length &lt; size) {<a name="line.142"></a>
<FONT color="green">143</FONT>                                    arr = new int[size];<a name="line.143"></a>
<FONT color="green">144</FONT>                            }                       <a name="line.144"></a>
<FONT color="green">145</FONT>                    }<a name="line.145"></a>
<FONT color="green">146</FONT>                    int index = 0;<a name="line.146"></a>
<FONT color="green">147</FONT>                    for (int i = start; i &lt; end; i++) {<a name="line.147"></a>
<FONT color="green">148</FONT>                            arr[index++] = i; <a name="line.148"></a>
<FONT color="green">149</FONT>                    }<a name="line.149"></a>
<FONT color="green">150</FONT>                    return arr;<a name="line.150"></a>
<FONT color="green">151</FONT>            }<a name="line.151"></a>
<FONT color="green">152</FONT>    <a name="line.152"></a>
<FONT color="green">153</FONT>            /** @return always null*/<a name="line.153"></a>
<FONT color="green">154</FONT>            public Comparator&lt;? super Integer&gt; comparator() {<a name="line.154"></a>
<FONT color="green">155</FONT>                    return null;<a name="line.155"></a>
<FONT color="green">156</FONT>            }<a name="line.156"></a>
<FONT color="green">157</FONT>            <a name="line.157"></a>
<FONT color="green">158</FONT>            @Override<a name="line.158"></a>
<FONT color="green">159</FONT>            public int firstInt() {<a name="line.159"></a>
<FONT color="green">160</FONT>                    if (start == end) {<a name="line.160"></a>
<FONT color="green">161</FONT>                            throw new NoSuchElementException();<a name="line.161"></a>
<FONT color="green">162</FONT>                    }<a name="line.162"></a>
<FONT color="green">163</FONT>                    return start;<a name="line.163"></a>
<FONT color="green">164</FONT>            }<a name="line.164"></a>
<FONT color="green">165</FONT>            @Override<a name="line.165"></a>
<FONT color="green">166</FONT>            public int lastInt() {<a name="line.166"></a>
<FONT color="green">167</FONT>                    if (start == end) {<a name="line.167"></a>
<FONT color="green">168</FONT>                            throw new NoSuchElementException();<a name="line.168"></a>
<FONT color="green">169</FONT>                    }<a name="line.169"></a>
<FONT color="green">170</FONT>                    return end - 1;<a name="line.170"></a>
<FONT color="green">171</FONT>            }<a name="line.171"></a>
<FONT color="green">172</FONT>            public RangeIntSet subSet(int from, int to) {<a name="line.172"></a>
<FONT color="green">173</FONT>                    if (from &gt; to) {<a name="line.173"></a>
<FONT color="green">174</FONT>                            throw new IllegalArgumentException("to must be greater or equal to from: " + to + " not &gt;= " + from);<a name="line.174"></a>
<FONT color="green">175</FONT>                    }<a name="line.175"></a>
<FONT color="green">176</FONT>                    final int newStart      = start + from;<a name="line.176"></a>
<FONT color="green">177</FONT>                    final int newEnd        = start + to;<a name="line.177"></a>
<FONT color="green">178</FONT>                    if (!containsInt(newStart)) {<a name="line.178"></a>
<FONT color="green">179</FONT>                            throw new IndexOutOfBoundsException("from index out of range: " + from);<a name="line.179"></a>
<FONT color="green">180</FONT>                    }<a name="line.180"></a>
<FONT color="green">181</FONT>                    if (!containsInt(newEnd)) {<a name="line.181"></a>
<FONT color="green">182</FONT>                            throw new IndexOutOfBoundsException("to index out of range: " + to);<a name="line.182"></a>
<FONT color="green">183</FONT>                    }<a name="line.183"></a>
<FONT color="green">184</FONT>                    return new RangeIntSet(newStart, newEnd);<a name="line.184"></a>
<FONT color="green">185</FONT>            }<a name="line.185"></a>
<FONT color="green">186</FONT>            @Override<a name="line.186"></a>
<FONT color="green">187</FONT>            public boolean equals(Object obj) {<a name="line.187"></a>
<FONT color="green">188</FONT>                    if (obj instanceof RangeIntSet) {<a name="line.188"></a>
<FONT color="green">189</FONT>                            final RangeIntSet rs = (RangeIntSet)obj;<a name="line.189"></a>
<FONT color="green">190</FONT>                            return start == rs.start &amp;&amp; end == rs.end;<a name="line.190"></a>
<FONT color="green">191</FONT>                    }<a name="line.191"></a>
<FONT color="green">192</FONT>                    return super.equals(obj);<a name="line.192"></a>
<FONT color="green">193</FONT>            }<a name="line.193"></a>
<FONT color="green">194</FONT>            <a name="line.194"></a>
<FONT color="green">195</FONT>            @Override<a name="line.195"></a>
<FONT color="green">196</FONT>            public int hashCode() {<a name="line.196"></a>
<FONT color="green">197</FONT>                    return start ^ end;<a name="line.197"></a>
<FONT color="green">198</FONT>            }<a name="line.198"></a>
<FONT color="green">199</FONT>            <a name="line.199"></a>
<FONT color="green">200</FONT>            @Override<a name="line.200"></a>
<FONT color="green">201</FONT>            public String toString() {<a name="line.201"></a>
<FONT color="green">202</FONT>                    return "[" + start + ".." + (end - 1) + "]";<a name="line.202"></a>
<FONT color="green">203</FONT>            }<a name="line.203"></a>
<FONT color="green">204</FONT>    <a name="line.204"></a>
<FONT color="green">205</FONT>    }<a name="line.205"></a>




























































</PRE>
</BODY>
</HTML>
